#
# Initialize
#	set the number of positions to max
#
set Gride 0
set Gseat 0
set wheel 0
set exit 0

proc vs_H_InitFerris { obj event userdata } {
	global vsTrue
	global wheel exit

	set wheel [ vsGetObjByName "ferris.wheel" ]	;# InitWorld
	set exit [ vsGetObjByName "Exit.panel" ]	;# InitWorld
}

proc vs_H_PeriodicRotateFerris { obj event userdata } {
	global vsTrue vsContinue

	# only master
	if [vscpAmIMaster == $vsTrue] {
		FerrisRotateValue $obj $event $userdata
        	vscpSendApplSpecificMsg $obj "FerrisRotateValue" "$userdata"
	}
	return $vsContinue
}

proc FerrisRotateValue { obj ev data } {
	global vsContinue vsCSWorld vsCSLocal vsAbsolute vsRelative 
	global Gride Gseat
	global worldobj world_rotate world_ride
	global wheel exit

	# set variable
#	set worldobj [ vsGetObjByName "world" ]

#	set rotate [ vsGetVariable $worldobj rotate ]
	set rotate $world_rotate

	incr rotate
	if { $rotate >= 72 } {
		set rotate 0
	}
#	vsSetVariable $worldobj rotate $rotate
	set world_rotate $rotate

	# next gondola come, clear seat
	set val [ expr fmod( $rotate, 9 ) ]
	if { $val == 0 } {
#		vsSetVariable $worldobj ride 0
		set world_ride 0
	}

#	vsMessageDlg "val: $rotate"

	# wheel
#	set wheel [ vsGetObjByName "ferris.wheel" ]
#	vsMessageDlg "wheel:$wheel"

	vsObjectRotateAngle $wheel  0.0 0.0 -5.0 $vsCSLocal $vsRelative

	# gondola
	for { set i 0 } { $i < 8 } { incr i } {
		set gon [ vsGetObjByName "ferris.wheel.gondola${i}.g${i}" ]
		vsObjectRotateAngle $gon  0.0 0.0 5.0 $vsCSLocal $vsRelative
	}
	# riding on gondola
	if { $Gride > 0 } {
		# check ride off
		set no [ expr $Gride - 1 ]
		set count [ expr $no * 9 ]
		if { $rotate == $count } {
			set Gride 0
			# set exit panel to ground
#			set exit [ vsGetObjByName "Exit.panel" ]
			vsTranslate $exit 0 -10 0 $vsCSWorld $vsAbsolute

			# sound off
			vsStopSoundByName sound_gondola

			return $vsContinue
		}
		# get obj postion
		set no [ expr $Gride - 1 ]
		set gon [ vsGetObjByName "ferris.wheel.gondola${no}.g${no}" ]
		vsGetObjWRT $gon x y z
		set camera [ vsGetPerson ]

		# set person to obj position
#		vsTranslate $camera $x $y $z $vsCSWorld $vsAbsolute

		if { $Gseat == 1 } {
#			vscpTranslate $camera 0.0 -2.0 -1.5 $vsCSWorld $vsRelative
			vscpTranslate $camera $x [ expr $y -2.0 ] [ expr $z -1.5 ] $vsCSWorld $vsAbsolute
		} else {
#			vscpTranslate $camera 0.0 -2.0 1.5 $vsCSWorld $vsRelative
			vscpTranslate $camera $x [ expr $y -2.0 ] [ expr $z +1.5 ] $vsCSWorld $vsAbsolute

		}

		# set exit obj to person
		vsGetObjWRT $camera x y z rx1 ry1 rz1 rx2 ry2 rz2 rx3 ry3 rz3
#		set exit [ vsGetObjByName "Exit.panel" ]
		vsTranslate $exit $x $y $z $vsCSWorld $vsAbsolute
#		vsRotate $exit $rx1 $ry1 $rz1 $rx2 $ry2 $rz2 $rx3 $ry3 $rz3 $vsCSWorld $vsAbsolute
#		vsTranslate $exit 0 0 2 $vsCSLocal $vsRelative
		if { $Gseat == 1 } {
			vsTranslate $exit 0 1.6 2.5 $vsCSWorld $vsRelative
		} else {
			vsTranslate $exit 0 1.6 -2.5 $vsCSWorld $vsRelative
		}

	}
	return $vsContinue
}


#
# ride on the Ferris
#
proc vs_H_Event_PickFerris { obj event userdata } {
	global Gride vsContinue Gseat
	global vsCSWorld vsAbsolute
	global worldobj world_rotate world_ride

	if { $Gride > 0 } {
		return $vsContinue
	}

	# get ride status
#	set worldobj [ vsGetObjByName "world" ]
#	set rideall [ vsGetVariable $worldobj ride ]
	set rideall $world_ride
	
	# vsMessageDlg "pick ride: $rideall : <$Gride>"

	# get available gondola
#	set rotate [ vsGetVariable $worldobj rotate ]
	set rotate $world_rotate

	set no [ expr int ([ expr $rotate / 9 ])]
	incr no

	# sound on
	vsPlayAmbientSoundByName sound_gondola 1

	# right seat
	if { $rideall == 0 } {
		set Gride $no	;# ride on
		set Gseat 1	;# right

		set camera [ vsGetPerson ]
		# set person to obj position
		vsRotateAngle $camera 0.0 0.0 0.0 $vsCSWorld $vsAbsolute

		RideFerrisMU $obj $event 1
		return $vsContinue

	} elseif { $rideall == 1 } {
		set Gride $no	;# ride on
		set Gseat 2	;# left

		set camera [ vsGetPerson ]
		# set person to obj position
		vsRotateAngle $camera 0.0 180.0 0.0 $vsCSWorld $vsAbsolute
		RideFerrisMU $obj $event 2
		return $vsContinue
	}
	return $vsContinue
}

#--------------------------------------
# Share the status of a gondola seat
#
proc RideFerrisMU  { obj event userdata } {
	global vsTrue vsContinue

	if [vscpAmIMaster == $vsTrue] {
		# I am Master
		RideFerris $obj $event $userdata
        	vscpSendApplSpecificMsg $obj "RideFerris" "$userdata"
	} {
		# I am Slave
		vscpSendApplSpecificMsg $obj "RideFerrisMU" "$userdata"
	}
	return $vsContinue
}

proc RideFerris { obj ev userdata } {
	global vsContinue vsCSWorld vsCSLocal vsAbsolute vsRelative 
	global Gride
	global world_ride
	
	# get ride status
#	set worldobj [ vsGetObjByName "world" ]
#	vsSetVariable $worldobj ride $userdata
	set world_ride $userdata

	# vsMessageDlg "ride: $userdata : <$Gride>"

	return $vsContinue
}

proc vs_H_Event_PickGetoff { obj event userdata } {
	global Gride Gseat
	global vsCSWorld vsAbsolute
	global exit

	set Gride 0
	set Gseat 0

	# set exit panel to ground
#	set exit [ vsGetObjByName "Exit.panel" ]
	vsTranslate $exit 0 -10 0 $vsCSWorld $vsAbsolute

	# sound off
	vsStopSoundByName sound_gondola
}

